(**************************************************************************)
(*                        Clock Abstraction                               *)
(*                                                                        *)
(*                                                                        *)
(* Authors: Louis Mandel (louis.mandel@lri.fr)                            *)
(*          Florence Plateau (florence.plateau@lri.fr)                    *)
(* Acknowledgement: Sylvie Boldo, Stephane Lescuyer and Matthieu Sozeau   *)
(*                                                                        *)
(* Creation date: July 2008                                               *)
(* Coq Version: 8.2beta3 (Jun. 2008)                                      *)
(*                                                                        *)
(**************************************************************************)
  
(* $Id: misc.v,v 1.1 2008-10-31 11:56:53 mandel Exp $ *)

Require Import Arith.

Theorem S_n_nbeq_n:
  forall n,
  beq_nat (S n) n = false.
Proof.
  intro.
  induction n.
    (* case n = 0 *)
    simpl.
    reflexivity.

    (* case n > 0 *)
    assert (H_aux:
      beq_nat (S (S n)) (S n) = beq_nat (S n) n).
      simpl.
      reflexivity.
    rewrite H_aux; clear H_aux.
    exact IHn.
Qed.

Require Import ZArith.
Remark Zeq_impl_nat_eq:
  forall n m: nat,
  (Z_of_nat n = Z_of_nat m)%Z -> (n = m)%nat.
Proof.
  intros.
  omega.
Qed.

